// AIOUSB.h : Header file for AIOUSB.dll
//
//For Borland C++ Builder, use CBAIOUSB.lib
//For Microsoft Visual C++, use VCAIOUSB.lib

#ifdef __cplusplus
extern "C" {
#endif



#define diNone 0xFFFFFFFF
#define diFirst 0xFFFFFFFE
#define diOnly 0xFFFFFFFD

#define TIME_METHOD_NOW 0
#define TIME_METHOD_WAIT_INPUT_ENABLE 86
#define TIME_METHOD_NOW_AND_ABORT 5
#define TIME_METHOD_WHEN_INPUT_ENABLE 1



__declspec(dllimport) unsigned long __cdecl GetDevices(void);
__declspec(dllimport) unsigned long __cdecl QueryDeviceInfo(unsigned long DeviceIndex, unsigned long *pPID, unsigned long *pNameSize, char *pName, unsigned long *pDIOBytes, unsigned long *pCounters);
__declspec(dllimport) unsigned long __cdecl AIOUSB_CloseDevice(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ClearDevices(void);
__declspec(dllimport) unsigned long __cdecl GetDeviceUniqueStr(unsigned long DeviceIndex, unsigned long *pUIDSize, char *pUID);
__declspec(dllimport) unsigned long __cdecl GetDeviceSerialNumber(unsigned long DeviceIndex, unsigned __int64 *pSerialNumber);
__declspec(dllimport) unsigned long __cdecl ResolveDeviceIndex(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl GetDeviceByEEPROMByte(unsigned char Data);
__declspec(dllimport) unsigned long __cdecl GetDeviceByEEPROMData(unsigned long StartAddress, unsigned long DataSize, unsigned char *pData);
__declspec(dllimport) unsigned long __cdecl GetDeviceBySerialNumber(unsigned __int64 *pSerialNumber);

__declspec(dllimport) unsigned long __cdecl AIOUSB_ClearFIFO(unsigned long DeviceIndex, unsigned long TimeMethod);
__declspec(dllimport) unsigned long __cdecl AIOUSB_GetStreamStatus(unsigned long DeviceIndex, unsigned long *Status);
__declspec(dllimport) unsigned long __cdecl AIOUSB_SetStreamingBlockSize(unsigned long DeviceIndex, unsigned long BlockSize);
__declspec(dllimport) unsigned long __cdecl AIOUSB_ResetChip(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl AIOUSB_ReloadDeviceLinks();
__declspec(dllimport) unsigned long __cdecl AIOUSB_UploadD15LoFirmwaresByPID(char *pFirmScript);

__declspec(dllimport) unsigned long __cdecl AIOUSB_QuerySimplePNPData(unsigned long DeviceIndex, void *pPNPData, unsigned long *pPNPDataBytes);

__declspec(dllimport) unsigned long __cdecl CustomEEPROMRead(unsigned long DeviceIndex, unsigned long StartAddress, unsigned long *DataSize, void *pData);
__declspec(dllimport) unsigned long __cdecl CustomEEPROMWrite(unsigned long DeviceIndex, unsigned long StartAddress, unsigned long DataSize, void *pData);
__declspec(dllimport) unsigned long __cdecl AIOUSB_FlashRead(unsigned long DeviceIndex, unsigned long StartAddress, unsigned long *DataSize, void *Data);
__declspec(dllimport) unsigned long __cdecl AIOUSB_FlashWrite(unsigned long DeviceIndex, unsigned long StartAddress, unsigned long DataSize, void *Data);
__declspec(dllimport) unsigned long __cdecl AIOUSB_FlashEraseSector(unsigned long DeviceIndex, signed long Sector);

__declspec(dllimport) unsigned long __cdecl GenericVendorRead(unsigned long DeviceIndex, unsigned char Request, unsigned short Value, unsigned short Index, unsigned long *pDataSize, void *pData);
__declspec(dllimport) unsigned long __cdecl GenericVendorWrite(unsigned long DeviceIndex, unsigned char Request, unsigned short Value, unsigned short Index, unsigned long DataSize, void *pData);
__declspec(dllimport) unsigned long __cdecl AWU_GenericBulkIn(unsigned long DeviceIndex, unsigned long PipeID, void *pData, unsigned long DataSize, unsigned long *pBytesRead);
__declspec(dllimport) unsigned long __cdecl AWU_GenericBulkOut(unsigned long DeviceIndex, unsigned long PipeID, void *pData, unsigned long DataSize, unsigned long *pBytesWritten);



__declspec(dllimport) unsigned long __cdecl ADC_GetScan(unsigned long DeviceIndex, unsigned short *pBuf);
__declspec(dllimport) unsigned long __cdecl ADC_GetScanV(unsigned long DeviceIndex, double *pBuf);
__declspec(dllimport) unsigned long __cdecl ADC_GetChannelV(unsigned long DeviceIndex, unsigned long ChannelIndex, double *pBuf);
__declspec(dllimport) unsigned long __cdecl ADC_GetCalRefV(unsigned long DeviceIndex, unsigned long CalRefIndex, double *pRef);

__declspec(dllimport) unsigned long __cdecl ADC_GetTrigScan(unsigned long DeviceIndex, unsigned short *pBuf, long TimeoutMS);
__declspec(dllimport) unsigned long __cdecl ADC_GetTrigScanV(unsigned long DeviceIndex, double *pBuf, long TimeoutMS);

__declspec(dllimport) unsigned long __cdecl ADC_GetConfig(unsigned long DeviceIndex, void *pConfigBuf, unsigned long *ConfigBufSize);
__declspec(dllimport) unsigned long __cdecl ADC_SetConfig(unsigned long DeviceIndex, void *pConfigBuf, unsigned long *ConfigBufSize);
__declspec(dllimport) unsigned long __cdecl ADC_ADMode(unsigned long DeviceIndex, unsigned char TriggerMode, unsigned char CalMode);
__declspec(dllimport) unsigned long __cdecl ADC_Range1(unsigned long DeviceIndex, unsigned long ADChannel, unsigned char GainCode, unsigned long bDifferential);
__declspec(dllimport) unsigned long __cdecl ADC_RangeAll(unsigned long DeviceIndex, unsigned char *pGainCodes, unsigned long bDifferential);
__declspec(dllimport) unsigned long __cdecl ADC_SetScanLimits(unsigned long DeviceIndex, unsigned long StartChannel, unsigned long EndChannel);
__declspec(dllimport) unsigned long __cdecl ADC_SetOversample(unsigned long DeviceIndex, unsigned char Oversample);
__declspec(dllimport) unsigned long __cdecl ADC_QueryCal(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ADC_SetCal(unsigned long DeviceIndex, char *CalFileName);
__declspec(dllimport) unsigned long __cdecl ADC_SetCalAndSave(unsigned long DeviceIndex, char *CalFileName, char *SaveCalFileName);
__declspec(dllimport) unsigned long __cdecl ADC_Initialize(unsigned long DeviceIndex, void *pConfigBuf, unsigned long *ConfigBufSize, char *CalFileName);
__declspec(dllimport) unsigned long __cdecl ADC_GetImmediate(unsigned long DeviceIndex, unsigned long Channel, unsigned short *pBuf);

__declspec(dllimport) unsigned long __cdecl ADC_BulkAcquire(unsigned long DeviceIndex, unsigned long BufSize, void *pBuf);
__declspec(dllimport) unsigned long __cdecl ADC_BulkPoll(unsigned long DeviceIndex, unsigned long *BytesLeft);
__declspec(dllimport) unsigned long __cdecl ADC_BulkAbort(unsigned long DeviceIndex);

__declspec(dllimport) unsigned long __cdecl ADC_BulkMode(unsigned long DeviceIndex, unsigned long BulkMode);
__declspec(dllimport) unsigned long __cdecl ADC_BulkContinuousCallbackStart(unsigned long DeviceIndex, unsigned long BufSize, unsigned long BaseBufCount, unsigned long Context, void *pCallback);
__declspec(dllimport) unsigned long __cdecl ADC_BulkContinuousCallbackStartClocked(unsigned long DeviceIndex, unsigned long BufSize, unsigned long BaseBufCount, unsigned long Context, void *pCallback, double *Hz);
__declspec(dllimport) unsigned long __cdecl ADC_BulkContinuousRingStart(unsigned long DeviceIndex, unsigned long RingBufferSize, unsigned long PacketsPerBlock);
__declspec(dllimport) unsigned long __cdecl ADC_BulkContinuousEnd(unsigned long DeviceIndex, unsigned long *pIOStatus);

__declspec(dllimport) unsigned long __cdecl ADC_FullStartRing(unsigned long DeviceIndex, void *pConfigBuf, unsigned long *ConfigBufSize, char *CalFileName, double *pCounterHz, unsigned long RingBufferSize, unsigned long PacketsPerBlock);
__declspec(dllimport) unsigned long __cdecl ADC_ReadData(unsigned long DeviceIndex, void *pConfigBuf, unsigned long *ScansToRead, double *pData, double Timeout);

__declspec(dllimport) unsigned long __cdecl ADC_InitFastITScanV(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ADC_ResetFastITScanV(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ADC_SetFastITScanVChannels(unsigned long DeviceIndex, unsigned long NewChannels);
__declspec(dllimport) unsigned long __cdecl ADC_GetFastITScanV(unsigned long DeviceIndex, double *pBuf);
__declspec(dllimport) unsigned long __cdecl ADC_GetITScanV(unsigned long DeviceIndex, double *pBuf);

__declspec(dllimport) unsigned long __cdecl ADC_InitFastScanV(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ADC_ResetFastScanV(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl ADC_GetFastScanV(unsigned long DeviceIndex, double *pBuf);



__declspec(dllimport) unsigned long __cdecl CTR_8254Load(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned short LoadValue);
__declspec(dllimport) unsigned long __cdecl CTR_8254Mode(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned long Mode);
__declspec(dllimport) unsigned long __cdecl CTR_8254ModeLoad(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned long Mode, unsigned short LoadValue);
__declspec(dllimport) unsigned long __cdecl CTR_8254Read(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned short *pReadValue);
__declspec(dllimport) unsigned long __cdecl CTR_8254ReadStatus(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned short *pReadValue, unsigned char *pStatus);
__declspec(dllimport) unsigned long __cdecl CTR_8254ReadModeLoad(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned long Mode, unsigned short LoadValue, unsigned short *pReadValue);

__declspec(dllimport) unsigned long __cdecl CTR_StartOutputFreq(unsigned long DeviceIndex, unsigned long CounterIndex, double *pHz);

__declspec(dllimport) unsigned long __cdecl CTR_8254ReadAll(unsigned long DeviceIndex, unsigned short *pData);

__declspec(dllimport) unsigned long __cdecl CTR_8254SelectGate(unsigned long DeviceIndex, unsigned long GateIndex);
__declspec(dllimport) unsigned long __cdecl CTR_8254ReadLatched(unsigned long DeviceIndex, unsigned short *pData);
__declspec(dllimport) unsigned long __cdecl CTR_SetWaitGates(unsigned long DeviceIndex, unsigned char A, unsigned char B);
__declspec(dllimport) unsigned long __cdecl CTR_EndWaitGates(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl CTR_WaitForGate(unsigned long DeviceIndex, unsigned char GateIndex, unsigned short *pContent);

__declspec(dllimport) unsigned long __cdecl CTR_StartMeasuringPulseWidth(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl CTR_StopMeasuringPulseWidth(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl CTR_GetPulseWidthMeasurement(unsigned long DeviceIndex, unsigned long BlockIndex, unsigned long CounterIndex, unsigned short *pReadValue);



__declspec(dllimport) unsigned long __cdecl DIO_Configure(unsigned long DeviceIndex, unsigned char bTristate, void *pOutMask, void *pData);
__declspec(dllimport) unsigned long __cdecl DIO_ConfigureEx(unsigned long DeviceIndex, void *pOutMask, void *pData, void *pTristateMask);
__declspec(dllimport) unsigned long __cdecl DIO_ConfigureMasked(unsigned long DeviceIndex, void *pOuts, void *pOutsMask, void *pData, void *pDataMask, void *pTristates, void *pTristatesMask);
__declspec(dllimport) unsigned long __cdecl DIO_ConfigurationQuery(unsigned long DeviceIndex, void *pOutMask, void *pTristateMask);

__declspec(dllimport) unsigned long __cdecl DIO_Read1(unsigned long DeviceIndex, unsigned long BitIndex, unsigned char *Buffer);
__declspec(dllimport) unsigned long __cdecl DIO_Read8(unsigned long DeviceIndex, unsigned long ByteIndex, unsigned char *pBuffer);
__declspec(dllimport) unsigned long __cdecl DIO_ReadAll(unsigned long DeviceIndex, void *Buffer);

__declspec(dllimport) unsigned long __cdecl DIO_Write1(unsigned long DeviceIndex, unsigned long BitIndex, unsigned char bData);
__declspec(dllimport) unsigned long __cdecl DIO_Write8(unsigned long DeviceIndex, unsigned long ByteIndex, unsigned char Data);
__declspec(dllimport) unsigned long __cdecl DIO_WriteAll(unsigned long DeviceIndex, void *pData);



__declspec(dllimport) unsigned long __cdecl DIO_StreamOpen(unsigned long DeviceIndex, unsigned long bIsRead);
__declspec(dllimport) unsigned long __cdecl DIO_StreamClose(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl DIO_StreamFrame(unsigned long DeviceIndex, unsigned long FramePoints, unsigned short *pFrameData, unsigned long *BytesTransferred);
__declspec(dllimport) unsigned long __cdecl DIO_StreamSetClocks(unsigned long DeviceIndex, double *ReadClockHz, double *WriteClockHz);

__declspec(dllimport) unsigned long __cdecl DIO_SPI_Read(unsigned long DeviceIndex, unsigned char Address, unsigned char Reg, unsigned char * pValue);
__declspec(dllimport) unsigned long __cdecl DIO_SPI_Write(unsigned long DeviceIndex, unsigned char Address, unsigned char Reg, unsigned char Value);

__declspec(dllimport) unsigned long __cdecl DIO_CSA_DoSync(unsigned long DeviceIndex, double * BaseRateHz, double * DurAms, double * DurBms, double * DurCms);
__declspec(dllimport) unsigned long __cdecl DIO_CSA_DebounceSet(unsigned long DeviceIndex, unsigned long DebounceCounts);
__declspec(dllimport) unsigned long __cdecl DIO_CSA_DebounceReadAll(unsigned long DeviceIndex, void *pData);

__declspec(dllimport) unsigned long __cdecl DAC_CSA_SetRangeLimits(unsigned long DeviceIndex, unsigned char *pData);
__declspec(dllimport) unsigned long __cdecl DAC_CSA_ClearRangeLimits(unsigned long DeviceIndex);

__declspec(dllimport) unsigned long __cdecl DACDIO_WriteAll(unsigned long DeviceIndex, unsigned short *pDACCounts, unsigned char *pDIOData);



__declspec(dllimport) unsigned long __cdecl DACDirect(unsigned long DeviceIndex, unsigned long Channel, unsigned short Counts);
__declspec(dllimport) unsigned long __cdecl DACMultiDirect(unsigned long DeviceIndex, void *pDACData, unsigned long DACDataCount);
__declspec(dllimport) unsigned long __cdecl DACSetBoardRange(unsigned long DeviceIndex, unsigned long RangeCode);
__declspec(dllimport) unsigned long __cdecl DACSetChannelCal(unsigned long DeviceIndex, unsigned long Channel, char *CalFileName);

__declspec(dllimport) unsigned long __cdecl DACOutputProcess(unsigned long DeviceIndex, double *ClockHz, unsigned long NumSamples, unsigned short *SampleData);

__declspec(dllimport) unsigned long __cdecl DACOutputOpen(unsigned long DeviceIndex, double *ClockHz);
__declspec(dllimport) unsigned long __cdecl DACOutputClose(unsigned long DeviceIndex, unsigned long bWait);
__declspec(dllimport) unsigned long __cdecl DACOutputCloseNoEnd(unsigned long DeviceIndex, unsigned long bWait);
__declspec(dllimport) unsigned long __cdecl DACOutputFrame(unsigned long DeviceIndex, unsigned long FramePoints, unsigned short *FrameData);
__declspec(dllimport) unsigned long __cdecl DACOutputFrameRaw(unsigned long DeviceIndex, unsigned long FramePoints, unsigned short *FrameData);
__declspec(dllimport) unsigned long __cdecl DACOutputSetCount(unsigned long DeviceIndex, unsigned long NewCount);
__declspec(dllimport) unsigned long __cdecl DACOutputStart(unsigned long DeviceIndex);
__declspec(dllimport) unsigned long __cdecl DACOutputSetInterlock(unsigned long DeviceIndex, unsigned long bInterlock);
__declspec(dllimport) unsigned long __cdecl DACOutputSetClock(unsigned long DeviceIndex, double *ClockHz);



//Note that all error codes returned are Windows error codes; they can be found in winerror.h in the Windows SDK, or on the Web.

#ifdef __cplusplus
}
#endif
